PROGRAM_NAME='CTG_DALI_Bsp'
(***********************************************************)
(*  FILE CREATED ON: 05/28/2004  AT: 11:16:35              *)
(***********************************************************)
(*  FILE_LAST_MODIFIED_ON: 07/21/2004  AT: 13:33:57        *)
(***********************************************************)

DEFINE_DEVICE

dvDALI    =    5001:1:0
vdvDALI   =   33001:1:0

dvPANEL   =     128:1:0


DEFINE_CONSTANT

long TL_VAL = 1
long TL_STAT = 2
long REL_TL_VAL[]  = { 100 }
long REL_TL_STAT[] = { 5000 }


DEFINE_VARIABLE

// -------------------------------
// fuer das Modul
volatile integer nANZAHL   =    10
volatile integer nDALI_VAL[64]
volatile integer nDALI_STAT[64]


// -------------------------------


// fuer das Programm

volatile integer nSEL_SPEED
volatile integer nCT_VAL



DEFINE_START


DEFINE_MODULE 'CT_DALI_1_mod' DALImod (vdvDALI,
                                       dvDALI,
                                       nANZAHL,
                                       nDALI_VAL,
                                       nDALI_STAT)



DEFINE_EVENT





BUTTON_EVENT[dvPANEL,1]    
{
	PUSH :        // alle EVGs sofort auf ihren Maximalwert setzen
	{
		PULSE[dvPANEL,1]
		SYSTEM_CALL 'CT_DALI_1_SetMax_NX'(vdvDALI,0)
	}
}
BUTTON_EVENT[dvPANEL,2]    
{
	PUSH :        // alle EVGs sofort auf ihren Minimalwert setzen
	{
		PULSE[dvPANEL,2]
		SYSTEM_CALL 'CT_DALI_1_SetMin_NX'(vdvDALI,0)
	}
}

// - Auswahl der Dauer, um eine Szene oder einen
//   Absolutwert anzufahren
// - Auswahl der Geschwindigkeit beim relativen Dimmen
BUTTON_EVENT[dvPANEL,11]
BUTTON_EVENT[dvPANEL,12]
BUTTON_EVENT[dvPANEL,13]
BUTTON_EVENT[dvPANEL,14]
BUTTON_EVENT[dvPANEL,15] 
BUTTON_EVENT[dvPANEL,16]
{
	PUSH :
	{
		nSEL_SPEED = (BUTTON.INPUT.CHANNEL - 10)    // --> Geschwindigkeit 2 - 10
	}
}

// Szenen antriggern
BUTTON_EVENT[dvPANEL,21]    // Szene 1 anfahren
BUTTON_EVENT[dvPANEL,22]    // Szene 2 anfahren
{
	PUSH :
	{
		TO[dvPANEL,(BUTTON.INPUT.CHANNEL)]
		SYSTEM_CALL 'CT_DALI_1_Scene_NX'(vdvDALI,101,(BUTTON.INPUT.CHANNEL - 20),nSEL_SPEED)
	}
}

// Gruppe 3 Direktwert mit angewaehlter Geschwindigkeit anfahren
BUTTON_EVENT[dvPANEL,31]    // 1%
{
	PUSH :
	{
		TO[dvPANEL,(BUTTON.INPUT.CHANNEL)]
		SYSTEM_CALL 'CT_DALI_1_SetAbs_NX'(vdvDALI,0,85,nSEL_SPEED)
	}
}
BUTTON_EVENT[dvPANEL,32]    // 20%
{
	PUSH :
	{
		TO[dvPANEL,(BUTTON.INPUT.CHANNEL)]
		SYSTEM_CALL 'CT_DALI_1_SetAbs_NX'(vdvDALI,0,195,nSEL_SPEED)
	}
}
BUTTON_EVENT[dvPANEL,33]    // 80%
{
	PUSH :
	{
		TO[dvPANEL,(BUTTON.INPUT.CHANNEL)]
		SYSTEM_CALL 'CT_DALI_1_SetAbs_NX'(vdvDALI,0,246,nSEL_SPEED)        
	}
}


// Gruppe 1 relativ dimmen
BUTTON_EVENT[dvPANEL,3]    // heller
BUTTON_EVENT[dvPANEL,4]    // dunkler
{
	PUSH :
	{
		TO[dvPANEL,BUTTON.INPUT.CHANNEL]
		SYSTEM_CALL 'CT_DALI_1_Dimm_NX'(vdvDALI,101,(BUTTON.INPUT.CHANNEL - 2),nSEL_SPEED)
	}
	RELEASE :              // stopp
	{
		SYSTEM_CALL 'CT_DALI_1_Dimm_NX'(vdvDALI,101,0,nSEL_SPEED)
	}
}



// -------------------------
// Textausgaben auf Panel
// (fuer die ersten 10 EVGs)
// -------------------------

DATA_EVENT[dvDALI]
{
	ONLINE :
	{
		TIMELINE_CREATE(TL_VAL ,REL_TL_VAL ,1,TIMELINE_RELATIVE,TIMELINE_Repeat)
		TIMELINE_CREATE(TL_STAT,REL_TL_STAT,1,TIMELINE_RELATIVE,TIMELINE_Repeat)
	}
}
/*
TIMELINE_EVENT[TL_STAT]
{
	STACK_VAR integer nCT
	FOR (nCT = 1; nCT < 11; nCT++)
	{
		SWITCH (nDALI_STAT[nCT])
		{
			CASE 0  : SEND_COMMAND dvPANEL,"'@TXT',(nCT + 100),'ok'"
			CASE 2  : SEND_COMMAND dvPANEL,"'@TXT',(nCT + 100),'Lampenfehler'"
			DEFAULT : SEND_COMMAND dvPANEL,"'@TXT',(nCT + 100),'EVG / Bus'"
		}
	}
}
*/

TIMELINE_EVENT[TL_VAL]
{
	nCT_VAL ++
	IF (nCT_VAL > nANZAHL)
	{
		nCT_VAL = 1
	}
	SEND_COMMAND dvPANEL,"'@TXT',(nCT_VAL+110),ITOA(nDALI_VAL[nCT_VAL])"
}




DEFINE_PROGRAM


// Geschwindigkeit
[dvPANEL,11] = (nSEL_SPEED = 1)
[dvPANEL,12] = (nSEL_SPEED = 2)
[dvPANEL,13] = (nSEL_SPEED = 3)
[dvPANEL,14] = (nSEL_SPEED = 4)
[dvPANEL,15] = (nSEL_SPEED = 5) 
[dvPANEL,16] = (nSEL_SPEED = 6)

[dvPANEL,101] = (nDALI_STAT[1])
[dvPANEL,102] = (nDALI_STAT[2])
[dvPANEL,103] = (nDALI_STAT[3])
[dvPANEL,104] = (nDALI_STAT[4])
[dvPANEL,105] = (nDALI_STAT[5])
[dvPANEL,106] = (nDALI_STAT[6])
[dvPANEL,107] = (nDALI_STAT[7])
[dvPANEL,108] = (nDALI_STAT[8])
[dvPANEL,109] = (nDALI_STAT[9])
[dvPANEL,110] = (nDALI_STAT[10])








